Index: trunk/kernel/kern/process.c
===================================================================
--- trunk/kernel/kern/process.c	(revision 690)
+++ trunk/kernel/kern/process.c	(revision 1)
@@ -1,18 +1,18 @@
 /*
- * process.c - process related functions definition.
- *
- * Authors  Ghassan Almaless       (2008,2009,2010,2011,2012)
+ * process.c - process related management
+ * 
+ * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
  *          Mohamed Lamine Karaoui (2015)
- *          Alain Greiner          (2016,2017,2018,2019,2020)
+ *          Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
  *
- * This file is part of ALMOS-MKH.
+ * This file is part of ALMOS-MKH..
  *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-MKH. is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-MKH. is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -20,14 +20,12 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <hal_remote.h>
 #include <hal_uspace.h>
-#include <hal_irqmask.h>
-#include <hal_vmm.h>
 #include <errno.h>
 #include <printk.h>
@@ -40,14 +38,7 @@
 #include <core.h>
 #include <thread.h>
-#include <chdev.h>
-#include <ksocket.h>
 #include <list.h>
-#include <string.h>
 #include <scheduler.h>
-#include <busylock.h>
-#include <queuelock.h>
-#include <remote_queuelock.h>
-#include <rwlock.h>
-#include <remote_rwlock.h>
+#include <remote_spinlock.h>
 #include <dqdt.h>
 #include <cluster.h>
@@ -56,6 +47,4 @@
 #include <process.h>
 #include <elf.h>
-#include <syscalls.h>
-#include <shared_syscalls.h>
 
 //////////////////////////////////////////////////////////////////////////////////////////
@@ -63,6 +52,5 @@
 //////////////////////////////////////////////////////////////////////////////////////////
 
-extern process_t           process_zero;     // allocated in kernel_init.c
-extern chdev_directory_t   chdev_dir;        // allocated in kernel_init.c
+extern process_t process_zero;
 
 //////////////////////////////////////////////////////////////////////////////////////////
@@ -70,315 +58,103 @@
 //////////////////////////////////////////////////////////////////////////////////////////
 
-////////////////////////////////////////////////////
-error_t process_reference_init( process_t * process,
-                                pid_t       pid,
-                                xptr_t      parent_xp )
-{
-    error_t     error;
-    xptr_t      process_xp;
-    cxy_t       parent_cxy;
-    process_t * parent_ptr;
-    xptr_t      stdin_xp;
-    xptr_t      stdout_xp;
-    xptr_t      stderr_xp;
-    uint32_t    stdin_id;
-    uint32_t    stdout_id;
-    uint32_t    stderr_id;
-    uint32_t    txt_id;
-    char        rx_path[40];
-    char        tx_path[40];
-    pid_t       parent_pid;
-    vmm_t     * vmm;
-
-#if DEBUG_PROCESS_REFERENCE_INIT || DEBUG_PROCESS_ERROR
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-#endif
-
-    // build extended pointer on reference process
-    process_xp = XPTR( local_cxy , process );
-
-    // get pointer on process vmm
-    vmm = &process->vmm;
-
-    // get parent process cluster and local pointer
-    parent_cxy = GET_CXY( parent_xp );
-    parent_ptr = GET_PTR( parent_xp );
-
-    // get parent_pid
-    parent_pid = hal_remote_l32( XPTR( parent_cxy , &parent_ptr->pid ) );
-
-#if DEBUG_PROCESS_REFERENCE_INIT
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] enter to initialize process %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, cycle );
-#endif
-
-    // initialize pid, ref_xp, parent_xp, owner_xp, term_state fields
-	process->pid        = pid;
-    process->ref_xp     = XPTR( local_cxy , process );
-    process->owner_xp   = XPTR( local_cxy , process );
-    process->parent_xp  = parent_xp;
-    process->term_state = 0;
-
-    // initialize VFS root inode and CWD inode
-    process->vfs_root_xp = hal_remote_l64( XPTR( parent_cxy, &parent_ptr->vfs_root_xp ) );
-    process->cwd_xp      = hal_remote_l64( XPTR( parent_cxy, &parent_ptr->cwd_xp ) );
-
-    // initialize VSL as empty
-    vmm->vsegs_nr = 0;
-	xlist_root_init( XPTR( local_cxy , &vmm->vsegs_root ) );
-
-    // create an empty GPT as required by the architecture
-    error = hal_gpt_create( &vmm->gpt );
-    if( error ) 
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot create empty GPT / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-        return -1;
-    }
-
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] created empty GPT for process %x\n",
-__FUNCTION__, parent_pid, this->trdid, pid );
-#endif
-
-    // initialize VSL lock
-	remote_rwlock_init( XPTR( local_cxy , &vmm->vsl_lock ) , LOCK_VMM_VSL );
-
-    // register kernel vsegs in user process VMM as required by the architecture
-    error = hal_vmm_kernel_update( process );
-    if( error ) 
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot register kernel vsegs in VMM / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-        printk("\n[ERROR] in %s : cannot register kernel vsegs in VMM\n", __FUNCTION__ );
-        return -1;
-    }
-
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] registered kernel vsegs in VSL for process %x\n",
-__FUNCTION__, parent_pid, this->trdid, pid );
-#endif
-
-    // create "args" and "envs" vsegs
-    // create "stacks" and "mmap" vsegs allocators 
-    // initialize locks protecting GPT and VSL
-    error = vmm_user_init( process );
-    if( error ) 
-    {
-        printk("\n[ERROR] in %s : cannot register user vsegs in VMM\n", __FUNCTION__ );
-        return -1;
-    }
- 
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] initialized vmm for process %x\n", 
-__FUNCTION__, parent_pid, this->trdid, pid );
-#endif
-
-    // initialize fd_array as empty
-    process_fd_init( process );
-
-    // define the stdin/stdout/stderr pseudo files <=> select a TXT terminal.
-    if( (pid == 1) || (parent_pid  == 1) )      // INIT or KSH  process
-    {
-        // select a TXT channel
-        if( pid == 1 )  txt_id = 0;                     // INIT
-        else            txt_id = process_txt_alloc();   // KSH
-
-        // attach process to TXT
-        process_txt_attach( process_xp , txt_id ); 
-
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] / process %x attached to TXT%d / cycle %d\n", 
-__FUNCTION__, parent_pid, this->trdid, pid, txt_id, cycle );
-#endif
-        // build path to TXT_RX[i] and TXT_TX[i] chdevs
-        snprintk( rx_path , 40 , "/dev/external/txt%d_rx", txt_id );
-        snprintk( tx_path , 40 , "/dev/external/txt%d_tx", txt_id );
-
-        // create stdin pseudo file          
-        error = vfs_open(  process->vfs_root_xp,
-                           rx_path,
-                           process_xp,
-                           O_RDONLY, 
-                           0,                // FIXME chmod
-                           &stdin_xp, 
-                           &stdin_id );
-        if( error )
-        {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot open stdin pseudo file / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-            return -1;
-        }
-
-assert( __FUNCTION__, (stdin_id == 0) , "stdin index must be 0" );
-
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] / stdin open for process %x / cycle %d\n", 
-__FUNCTION__, parent_pid, this->trdid, pid, cycle );
-#endif
-
-        // create stdout pseudo file          
-        error = vfs_open(  process->vfs_root_xp,
-                           tx_path,
-                           process_xp,
-                           O_WRONLY, 
-                           0,                // FIXME chmod
-                           &stdout_xp, 
-                           &stdout_id );
-        if( error )
-        {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot open stdout pseudo file / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-            return -1;
-        }
-
-assert( __FUNCTION__, (stdout_id == 1) , "stdout index must be 1" );
-
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] / stdout open for process %x / cycle %d\n", 
-__FUNCTION__, parent_pid, this->trdid, pid, cycle );
-#endif
-
-        // create stderr pseudo file          
-        error = vfs_open(  process->vfs_root_xp,
-                           tx_path,
-                           process_xp,
-                           O_WRONLY, 
-                           0,                // FIXME chmod
-                           &stderr_xp, 
-                           &stderr_id );
-        if( error )
-        {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot open stderr pseudo file / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-            return -1;
-        }
-
-assert( __FUNCTION__, (stderr_id == 2) , "stderr index must be 2" );
-
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] / stderr open for process %x / cycle %d\n", 
-__FUNCTION__, parent_pid, this->trdid, pid, cycle );
-#endif
-
-    }
-    else                                            // normal user process 
-    {
-        // get parent process TXT index
-        txt_id = process_txt_get_index( parent_xp );
-
-        // attach child process to same TXT terminal as parent
-        process_txt_attach( process_xp , txt_id ); 
-
-        // recreate all open files from parent process fd_array to child process fd_array
-        error = process_fd_replicate( process_xp , parent_xp );
-
-        if( error )
-        {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot replicate fd_array / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-            return -1;
-        }
-
-    }
-
-    // initialize lock protecting CWD changes
-    remote_busylock_init( XPTR( local_cxy , &process->cwd_lock ), LOCK_PROCESS_CWD );
-
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] / set fd_array for process %x / cycle %d\n", 
-__FUNCTION__, parent_pid, this->trdid, pid , cycle );
-#endif
-
-    // reset children list root 
+///////////////////////////
+process_t * process_alloc()
+{
+	kmem_req_t   req;
+
+    req.type  = KMEM_PROCESS;
+	req.size  = sizeof(process_t);
+	req.flags = AF_KERNEL;
+
+    return (process_t *)kmem_alloc( &req );
+}
+
+////////////////////////////////////////
+void process_free( process_t * process )
+{
+    kmem_req_t  req;
+
+	req.type = KMEM_PROCESS;
+	req.ptr  = process;
+	kmem_free( &req );
+}
+
+////////////////////////////////////////////
+void process_zero_init( boot_info_t * info )
+{
+    // reset process descriptor
+	memset( &process_zero , 0 , sizeof(process_t) );
+
+    // initialize kernel code & data vsegs base addresses
+	process_zero.vmm.code_vpn_base = (vpn_t)(info->kernel_code_start >> CONFIG_PPM_PAGE_SHIFT);
+	process_zero.vmm.data_vpn_base = (vpn_t)(info->kernel_data_start >> CONFIG_PPM_PAGE_SHIFT);
+
+    // reset threads and childs number
+	process_zero.th_nr       = 0;
+	process_zero.children_nr = 0;
+
+    // set PID 
+	process_zero.pid            = 0;
+}
+
+/////////////////////////////////////////////////
+void process_reference_init( process_t * process,
+                             pid_t       pid,
+                             pid_t       ppid )
+{
+    // reset signal manager  TODO [AG]
+
+    // reset the file descriptors array 
+	process_fd_init( process );
+
+    // reset the process files structures and cd_lock
+	process->vfs_root_xp     = XPTR_NULL;
+	process->vfs_cwd_xp      = XPTR_NULL;
+	process->vfs_bin_xp      = XPTR_NULL;
+
+    spinlock_init( &process->cd_lock );
+
+    // reset children list root
     xlist_root_init( XPTR( local_cxy , &process->children_root ) );
-    process->children_nr     = 0;
-    remote_queuelock_init( XPTR( local_cxy,
-                                 &process->children_lock ), LOCK_PROCESS_CHILDREN );
-
-    // reset semaphore / mutex / barrier / condvar list roots and lock
+	process->children_nr     = 0;
+
+    // reset semaphore list root
     xlist_root_init( XPTR( local_cxy , &process->sem_root ) );
-    xlist_root_init( XPTR( local_cxy , &process->mutex_root ) );
-    xlist_root_init( XPTR( local_cxy , &process->barrier_root ) );
-    xlist_root_init( XPTR( local_cxy , &process->condvar_root ) );
-    remote_queuelock_init( XPTR( local_cxy , 
-                                 &process->sync_lock ), LOCK_PROCESS_USERSYNC );
-
-    // reset open directories root and lock 
-    xlist_root_init( XPTR( local_cxy , &process->dir_root ) );
-    remote_queuelock_init( XPTR( local_cxy , 
-                                 &process->dir_lock ), LOCK_PROCESS_DIR );
-
-    // register new process in the local cluster manager pref_tbl[]
-    lpid_t lpid = LPID_FROM_PID( pid );
-    LOCAL_CLUSTER->pmgr.pref_tbl[lpid] = XPTR( local_cxy , process );
+	process->sem_nr          = 0;
+
+    // register new process in the parent children list
+    xptr_t entry = XPTR( local_cxy , &process->brothers_list );
+    xptr_t root  = XPTR( local_cxy , &process->children_root );
+    xlist_add_first( root , entry );
+    
+    // reset th_tbl[] array
+    uint32_t i;
+    for( i = 0 ; i < CONFIG_THREAD_MAX_PER_CLUSTER ; i++ )
+	{
+        process->th_tbl[i] = NULL;
+    }
+    process->th_nr  = 0;
+    spinlock_init( &process->th_lock );
+
+    // reset process VMM 
+	memset( &process->vmm , 0 , sizeof(vmm_t) );
+
+    // initialize PID and PPID
+	process->pid   = pid;
+    process->ppid  = ppid;
+
+    // set ref_xp field and is_ref flag
+    process->is_ref = true;
+    process->ref_xp = XPTR( local_cxy , process );
 
     // register new process descriptor in local cluster manager local_list
     cluster_process_local_link( process );
 
-    // register new process descriptor in local cluster manager copies_list 
+    // register new process descriptor in owner cluster manager copies_list
     cluster_process_copies_link( process );
 
-    // initialize th_tbl[] array and associated threads
-    uint32_t i;
-
-    for( i = 0 ; i < CONFIG_THREADS_MAX_PER_CLUSTER ; i++ )
-	{
-        process->th_tbl[i] = NULL;
-    }
-    process->th_nr  = 0;
-    rwlock_init( &process->th_lock , LOCK_PROCESS_THTBL );
-
-	hal_fence();
-
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_REFERENCE_INIT < cycle )
-printk("\n[%s] thread[%x,%x] exit for process %x / cycle %d\n", 
-__FUNCTION__, parent_pid, this->trdid, pid, cycle );
-#endif
-
-#if (DEBUG_PROCESS_REFERENCE_INIT & 1)
-hal_vmm_display( parent_xp , false );
-hal_vmm_display( XPTR( local_cxy , process ) , false );
-#endif
-
-    return 0;
-
-}  // process_reference_init()
+	hal_wbflush();
+
+} // end process_reference_init()
 
 /////////////////////////////////////////////////////
@@ -386,121 +162,39 @@
                            xptr_t      reference_process_xp )
 {
-    error_t   error;
-    vmm_t   * vmm;
-
-#if DEBUG_PROCESS_COPY_INIT || DEBUG_PROCESS_ERROR
-thread_t * this = CURRENT_THREAD;  
-uint32_t cycle = (uint32_t)hal_get_cycles();
-#endif
-
-    // get reference process cluster and local pointer
-    cxy_t       ref_cxy = GET_CXY( reference_process_xp );
-    process_t * ref_ptr = GET_PTR( reference_process_xp );
-
-    // get pointer on process vmm
-    vmm = &local_process->vmm;
-
-    // initialize PID, REF_XP, PARENT_XP, and STATE
-    local_process->pid        = hal_remote_l32(  XPTR( ref_cxy , &ref_ptr->pid ) );
-    local_process->parent_xp  = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->parent_xp ) );
-    local_process->ref_xp     = reference_process_xp;
-    local_process->owner_xp   = reference_process_xp;
-    local_process->term_state = 0;
-
-#if DEBUG_PROCESS_COPY_INIT
-if( DEBUG_PROCESS_COPY_INIT < cycle )
-printk("\n[%s] thread[%x,%x] enter for process %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, local_process->pid, cycle );
-#endif
-
-// check user process
-assert( __FUNCTION__, (local_process->pid != 0), "LPID cannot be 0" );
-
-    // initialize VSL as empty
-    vmm->vsegs_nr = 0;
-	xlist_root_init( XPTR( local_cxy , &vmm->vsegs_root ) );
-
-    // create an empty GPT as required by the architecture
-    error = hal_gpt_create( &vmm->gpt );
-
-    if( error ) 
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot create empty GPT / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-        return -1;
-    }
-
-    // initialize GPT and VSL locks
-	remote_rwlock_init( XPTR( local_cxy , &vmm->vsl_lock ) , LOCK_VMM_VSL );
-
-    // register kernel vsegs in VMM as required by the architecture
-    error = hal_vmm_kernel_update( local_process );
-
-    if( error ) 
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot register kernel vsegs in VMM / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-        return -1;
-    }
-
-    // create "args" and "envs" vsegs
-    // create "stacks" and "mmap" vsegs allocators 
-    // initialize locks protecting GPT and VSL
-    error = vmm_user_init( local_process );
-
-    if( error ) 
-    {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot register user vsegs in VMM / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-        return -1;
-    }
- 
-#if (DEBUG_PROCESS_COPY_INIT & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_COPY_INIT < cycle )
-printk("\n[%s] thread[%x,%x] initialized vmm for process %x / cycle %d\n", 
-__FUNCTION__, parent_pid, this->trdid, pid, cycle );
-#endif
-
-    // set process file descriptors array
-	process_fd_init( local_process );
-
-    // set vfs_root_xp / vfs_bin_xp / cwd_xp fields
-    local_process->vfs_root_xp = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->vfs_root_xp ) );
-    local_process->vfs_bin_xp  = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->vfs_bin_xp ) );
-    local_process->cwd_xp      = XPTR_NULL;
+    // replicate the remote process descriptor in new process descriptor
+    xptr_t local_process_xp = XPTR( local_cxy , local_process );
+    hal_remote_memcpy( local_process_xp , reference_process_xp , sizeof(process_t) );
+
+    // initalise signal manager TODO [AG]
+
+    // initialise file descriptors array TODO [AG]
+
+    // initialise process files structures TODO [AG]
+
+    // set the ref_xp field and clear the is_ref flag
+    local_process->ref_xp = reference_process_xp;
+    local_process->is_ref = false;
 
     // reset children list root (not used in a process descriptor copy)
     xlist_root_init( XPTR( local_cxy , &local_process->children_root ) );
-    local_process->children_nr   = 0;
-    remote_queuelock_init( XPTR( local_cxy , &local_process->children_lock ),
-                           LOCK_PROCESS_CHILDREN );
-
-    // reset children_list (not used in a process descriptor copy)
-    xlist_entry_init( XPTR( local_cxy , &local_process->children_list ) );
+    local_process->children_nr   = 0;           
+
+    // reset brothers list (not used in a process descriptor copy)
+    xlist_entry_init( XPTR( local_cxy , &local_process->brothers_list ) );
 
     // reset semaphores list root (not used in a process descriptor copy)
     xlist_root_init( XPTR( local_cxy , &local_process->sem_root ) );
-    xlist_root_init( XPTR( local_cxy , &local_process->mutex_root ) );
-    xlist_root_init( XPTR( local_cxy , &local_process->barrier_root ) );
-    xlist_root_init( XPTR( local_cxy , &local_process->condvar_root ) );
-
-    // initialize th_tbl[] array and associated fields
+    local_process->sem_nr        = 0;           
+
+    // initialize th_tbl[] array as empty
     uint32_t i;
-    for( i = 0 ; i < CONFIG_THREADS_MAX_PER_CLUSTER ; i++ )
+    for( i = 0 ; i < CONFIG_THREAD_MAX_PER_CLUSTER ; i++ )
 	{
         local_process->th_tbl[i] = NULL;
     }
     local_process->th_nr  = 0;
-    rwlock_init( &local_process->th_lock , LOCK_PROCESS_THTBL );
+    spinlock_init( &local_process->th_lock );
+
+    // initialise  process VMM TODO [AG]
 
     // register new process descriptor in local cluster manager local_list
